"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "COORDINATE_SYSTEM", {
  enumerable: true,
  get: function get() {
    return _constants.COORDINATE_SYSTEM;
  }
});
Object.defineProperty(exports, "Deck", {
  enumerable: true,
  get: function get() {
    return _deck.default;
  }
});
Object.defineProperty(exports, "LayerManager", {
  enumerable: true,
  get: function get() {
    return _layerManager.default;
  }
});
Object.defineProperty(exports, "AttributeManager", {
  enumerable: true,
  get: function get() {
    return _attributeManager.default;
  }
});
Object.defineProperty(exports, "Layer", {
  enumerable: true,
  get: function get() {
    return _layer.default;
  }
});
Object.defineProperty(exports, "CompositeLayer", {
  enumerable: true,
  get: function get() {
    return _compositeLayer.default;
  }
});
Object.defineProperty(exports, "Viewport", {
  enumerable: true,
  get: function get() {
    return _viewport.default;
  }
});
Object.defineProperty(exports, "WebMercatorViewport", {
  enumerable: true,
  get: function get() {
    return _webMercatorViewport.default;
  }
});
Object.defineProperty(exports, "project", {
  enumerable: true,
  get: function get() {
    return _project.default;
  }
});
Object.defineProperty(exports, "project64", {
  enumerable: true,
  get: function get() {
    return _project2.default;
  }
});
Object.defineProperty(exports, "lighting", {
  enumerable: true,
  get: function get() {
    return _lighting.default;
  }
});
Object.defineProperty(exports, "View", {
  enumerable: true,
  get: function get() {
    return _view.default;
  }
});
Object.defineProperty(exports, "MapView", {
  enumerable: true,
  get: function get() {
    return _mapView.default;
  }
});
Object.defineProperty(exports, "FirstPersonView", {
  enumerable: true,
  get: function get() {
    return _firstPersonView.default;
  }
});
Object.defineProperty(exports, "ThirdPersonView", {
  enumerable: true,
  get: function get() {
    return _thirdPersonView.default;
  }
});
Object.defineProperty(exports, "OrbitView", {
  enumerable: true,
  get: function get() {
    return _orbitView.default;
  }
});
Object.defineProperty(exports, "PerspectiveView", {
  enumerable: true,
  get: function get() {
    return _perspectiveView.default;
  }
});
Object.defineProperty(exports, "OrthographicView", {
  enumerable: true,
  get: function get() {
    return _orthographicView.default;
  }
});
Object.defineProperty(exports, "Controller", {
  enumerable: true,
  get: function get() {
    return _controller.default;
  }
});
Object.defineProperty(exports, "MapController", {
  enumerable: true,
  get: function get() {
    return _mapController.default;
  }
});
Object.defineProperty(exports, "_FirstPersonController", {
  enumerable: true,
  get: function get() {
    return _firstPersonController.default;
  }
});
Object.defineProperty(exports, "_OrbitController", {
  enumerable: true,
  get: function get() {
    return _orbitController.default;
  }
});
Object.defineProperty(exports, "_OrthographicController", {
  enumerable: true,
  get: function get() {
    return _orthographicController.default;
  }
});
Object.defineProperty(exports, "_EffectManager", {
  enumerable: true,
  get: function get() {
    return _effectManager.default;
  }
});
Object.defineProperty(exports, "_Effect", {
  enumerable: true,
  get: function get() {
    return _effect.default;
  }
});
Object.defineProperty(exports, "_ReflectionEffect", {
  enumerable: true,
  get: function get() {
    return _reflectionEffect.default;
  }
});
Object.defineProperty(exports, "TRANSITION_EVENTS", {
  enumerable: true,
  get: function get() {
    return _transitionManager.TRANSITION_EVENTS;
  }
});
Object.defineProperty(exports, "LinearInterpolator", {
  enumerable: true,
  get: function get() {
    return _linearInterpolator.default;
  }
});
Object.defineProperty(exports, "FlyToInterpolator", {
  enumerable: true,
  get: function get() {
    return _viewportFlyToInterpolator.default;
  }
});
Object.defineProperty(exports, "log", {
  enumerable: true,
  get: function get() {
    return _log.default;
  }
});
Object.defineProperty(exports, "_GPUGridAggregator", {
  enumerable: true,
  get: function get() {
    return _gpuGridAggregator.default;
  }
});
Object.defineProperty(exports, "_pointToDensityGridData", {
  enumerable: true,
  get: function get() {
    return _gridAggregationUtils.pointToDensityGridData;
  }
});
exports.experimental = void 0;

require("./lib/init");

require("./shaderlib");

var _constants = require("./lib/constants");

var _deck = _interopRequireDefault(require("./lib/deck"));

var _layerManager = _interopRequireDefault(require("./lib/layer-manager"));

var _attributeManager = _interopRequireDefault(require("./lib/attribute-manager"));

var _layer = _interopRequireDefault(require("./lib/layer"));

var _compositeLayer = _interopRequireDefault(require("./lib/composite-layer"));

var _viewport = _interopRequireDefault(require("./viewports/viewport"));

var _webMercatorViewport = _interopRequireDefault(require("./viewports/web-mercator-viewport"));

var _project = _interopRequireDefault(require("./shaderlib/project/project"));

var _project2 = _interopRequireDefault(require("./shaderlib/project64/project64"));

var _lighting = _interopRequireDefault(require("./shaderlib/lighting/lighting"));

var _view = _interopRequireDefault(require("./views/view"));

var _mapView = _interopRequireDefault(require("./views/map-view"));

var _firstPersonView = _interopRequireDefault(require("./views/first-person-view"));

var _thirdPersonView = _interopRequireDefault(require("./views/third-person-view"));

var _orbitView = _interopRequireDefault(require("./views/orbit-view"));

var _perspectiveView = _interopRequireDefault(require("./views/perspective-view"));

var _orthographicView = _interopRequireDefault(require("./views/orthographic-view"));

var _controller = _interopRequireDefault(require("./controllers/controller"));

var _mapController = _interopRequireDefault(require("./controllers/map-controller"));

var _firstPersonController = _interopRequireDefault(require("./controllers/first-person-controller"));

var _orbitController = _interopRequireDefault(require("./controllers/orbit-controller"));

var _orthographicController = _interopRequireDefault(require("./controllers/orthographic-controller"));

var _effectManager = _interopRequireDefault(require("./experimental/lib/effect-manager"));

var _effect = _interopRequireDefault(require("./experimental/lib/effect"));

var _reflectionEffect = _interopRequireDefault(require("./experimental/reflection-effect/reflection-effect"));

var _transitionManager = require("./controllers/transition-manager");

var _linearInterpolator = _interopRequireDefault(require("./transitions/linear-interpolator"));

var _viewportFlyToInterpolator = _interopRequireDefault(require("./transitions/viewport-fly-to-interpolator"));

var _log = _interopRequireDefault(require("./utils/log"));

var _flatten = require("./utils/flatten");

var _binSorter = _interopRequireDefault(require("./utils/bin-sorter"));

var _colorUtils = require("./utils/color-utils");

var _scaleUtils = require("./utils/scale-utils");

var _gpuGridAggregator = _interopRequireDefault(require("./experimental/utils/gpu-grid-aggregation/gpu-grid-aggregator"));

var _gridAggregationUtils = require("./experimental/utils/gpu-grid-aggregation/grid-aggregation-utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// Copyright (c) 2015 - 2017 Uber Technologies, Inc.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files (the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

/* eslint-disable max-len */
// Intialize globals, check version
// Import shaderlib to make sure shader modules are initialized
// Core Library
// Experimental Pure JS (non-React) bindings
// Viewports
// Shader modules
// Controllers
// Experimental Controllers
// EXPERIMENTAL EXPORTS
// Experimental Effects (non-React) bindings
// Eperimental Transitions
// Layer utilities
// Export? move to luma.gl or math.gl?
// Exports for layers
// Experimental Features may change in minor version bumps, use at your own risk)
var experimental = {
  BinSorter: _binSorter.default,
  linearScale: _scaleUtils.linearScale,
  getLinearScale: _scaleUtils.getLinearScale,
  quantizeScale: _scaleUtils.quantizeScale,
  getQuantizeScale: _scaleUtils.getQuantizeScale,
  defaultColorRange: _colorUtils.defaultColorRange,
  flattenVertices: _flatten.flattenVertices,
  fillArray: _flatten.fillArray
};
exports.experimental = experimental;
//# sourceMappingURL=index.js.map